--Parsec music 1.0
--Vendetta music replacement by Phil Spencer
parsec = {}

parsec.nextsong = Timer()
parsec.lastsong = nil
parsec.systemcheck = 0
parsec.on = 0
parsec.music = {
	title  = 'playmusic plugins/parsecmusic/parsecmenu.ogg',
	system = 'playmusic plugins/parsecmusic/parsecsystem.ogg',
	[1]    = {'playmusic plugins/parsecmusic/track2.ogg',233},
	[2]    = {'playmusic plugins/parsecmusic/track3.ogg',466},
	[3]    = {'playmusic plugins/parsecmusic/track4.ogg',371},
	[4]    = {'playmusic plugins/parsecmusic/track5.ogg',452},
	[5]    = {'playmusic plugins/parsecmusic/track6.ogg',200},
	[6]    = {'playmusic plugins/parsecmusic/track7.ogg',315},
	[7]    = {'playmusic plugins/parsecmusic/track8.ogg',328},
	[8]    = {'playmusic plugins/parsecmusic/track9.ogg',387},
	[9]    = {'playmusic plugins/parsecmusic/track10.ogg',280},
	[10]   = {'playmusic plugins/parsecmusic/track11.ogg',209},
	[11]   = {'playmusic plugins/parsecmusic/track12.ogg',285},
	[12]   = {'playmusic plugins/parsecmusic/track13.ogg',176},
}

function parsec.music_entergame()
   	parsec.systemcheck = 0
end

function parsec.music_random()
	if parsec.on == 0 then
		return
	end
	local song     = math.random(12)
	local duration = parsec.music[song][2] * 1000

   	if parsec.nextsong:IsActive() then
    	return
   	end
   	if song == parsec.lastsong then 
    	parse.music_random()
      	return   
   	end
   	parsec.lastsong = song
   	if parsec.systemcheck == 0 then
    	gkinterface.GKProcessCommand(parsec.music['system'])
      	parsec.nextsong:SetTimeout(15000,parsec.music_random)
      	parsec.systemcheck = 1
      	return
   	end
   	parsec.nextsong:SetTimeout(duration,parsec.music_random)
   	gkinterface.GKProcessCommand(parsec.music[song][1])   
end

function parsec.music_spawnspace()
	if parsec.on == 0 then
		return
	end
	if parsec.systemcheck == 0 then
      	gkinterface.GKProcessCommand(parsec.music['system'])
      	parsec.nextsong:SetTimeout(15000,parsec.music_random)
      	parsec.systemcheck = 1
   	else
      	return
   	end
end

function parsec.theme()
	if parsec.on == 0 then
		return
	end
	gkinterface.GKProcessCommand(parsec.music['title'])	
end

--User Command functions 
function parsec.setDefault()
	gkini.WriteString("csmusic", "default", "parsec")
	parsec.defaults = "parsec"
end

function parsec.getDefault()
	parsec.defaults = gkini.ReadString("csmusic", "default", "")
	if parsec.defaults == "" then
		--No other CrazySpence music plugin has set default so set default now
		parsec.setDefault()
	end
end

function parsec.init()
	parsec.getDefault()
	if parsec.defaults == "parsec" then 
		parsec.on = 1 		
	end
end

function parsec.stop()
	parsec.on = 0
	gkinterface.GKProcessCommand('stopmusic');
end

function parsec.start()
	parsec.on = 1
	parsec.music_random()
end

parsec.init()

--Event Handlers
RegisterEvent(parsec.music_entergame,"PLAYER_ENTERED_GAME")
RegisterEvent(parsec.music_random,"LEAVING_STATION")
RegisterEvent(parsec.music_spawnspace,"HUD_SHOW")
--Uncomment the line below if you want the Parsec theme to replace the opening theme
RegisterEvent(parsec.theme,"START")
--Command Handlers
RegisterUserCommand('parsecdefault',parsec.setDefault)
RegisterUserCommand('parsecstop',parsec.stop)
RegisterUserCommand('parsecstart',parsec.start)